;0TEMPALARME210414
;Se connecte par 3 fils au +12V du cadran de temprature, sa masse et la sortie sonde.
;On utilise le tmoin rouge d'alerte de pression d'huile pour signaler un dpassement de la temprature d'alarme 

; En option on peut aussi connecter un fil au tmoin lumineux vert  des clignotants: le buzzer sera actionn en mme temps que lce tmoin

;;;;;;;;;;;;;;;CALIBRATION:  effectuer une fois pour fixer la temprature d'alarme soyuhaite

;On calibre la remprature d'alarme avec le bouton poussoir BP ainsi que le potentiomtre.
;Si le  BP est pouss AVANT la mise du contact, on est en mode calibration: BP maintenu,  on tourne le potentiomtre pour amener l'aiguille sur sa position d'alarme souhaite
;Pour achever la calibration, on relache le BP (les valeurs Valim  et Vsonde calibres sont stockes en EEPROM 0  3)

;;;;;;;;;;;;;;;;;;;;UTILISATION NORMALE

;En mode normal, le logiciel  relit ces valeurs d'alarme de l'EEPROM et les compare aux Valim et Vsonde instantanes.
;Si la temprature atteint la valeur d'alarme, le buzzer et la lampe tmoin s'activent.
;On peut, si dsir, arreter le buzzer en appuyant une fois sur les BP, mais la lampe reste toujours allume tant que la temprature est > T alarme


; Ce logiciel utilise la bibli D_Arith pour les oprations sur 16 bits

;Aprs debug, mode Production, pas de quartz, MCLR ON,. Paramtre DEBUG sans influence
;Pour oscillateur INTERNE 4MHz ,  _INTRC_IO  et OSCCON =h'60' ;OSCCON sans influence donc rien  changer dans le code si HS_OSC
;PIEGESi  MCLR_Off,  la pin 4 est libre pour l'utiliser en INPUT seulement!!!

       list      p=16F88             ; list directive to define processor
       #include <p16F88.inc>         ; processor specific variable definitions
		ERRORLEVEL	-302			;pas de warnings pour les banks
;Program Configuration Register 1  PIEGE sur 16F88: il FAUT _HS_OSC meme  4MHz!!!


		__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_OFF & _WDT_Off & _HS_OSC
		__CONFIG    _CONFIG2, _IESO_Off & _FCMEN_OFF
		
;	__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_OFF & _WDT_Off & _INTRC_IO		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Laisse  0 ou mettre 1 suivant le type de cadran;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
lCADRAN	equ 	0		;capteur non connect, 0 si l'aiguille du cadran  reste au zro (usuel sur A110 1600), 1 si elle vient sur 4/4	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	#DEFINE	BUZ		PORTB,2			;Buzzer, pin 8, 	
	#DEFINE	LAMPE		PORTB,3			;pin 9, LAMPE par exemple, le tmoin orange de frein  main
	#DEFINE	BP			PORTB,0			;pin6, entre du BP	,BP pouss, ON, pin6 =1
	#DEFINE	CLI			PORTB,4			;Rappel de clignotatnt,pin 10
	
	#DEFINE AL	ACCALO  			;abbrviation + facile  crire pour les accumulateurs de D_arith
	#DEFINE AH	ACCaHI  
	#DEFINE BL	ACCbLO  
	#DEFINE BH	ACCbHI  
	#DEFINE CL	ACCcLO 
	#DEFINE CH	ACCcHI 
	
;    Librairie D_arith       D_add,D-sub, D_mpy,D_div        b+a ds b;;;;;			;;b  - a  ds b;;;;				;a*b  ds bHigh  cLow;;;;;;32 bits 		 b/a  res ds b, reste d
;Entres CAN ,	  D2=pin1,A2   	D3=pin2,A3,   	D4=pin3,A4  INPUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Les variables		
    cblock  h'20' 
      ACCALO  				;variables de la lib  D_Arith
	ACCAHI  
	ACCBLO  
	ACCBHI  
	ACCCLO 
	ACCCHI  
	ACCDLO  
	ACCDHI  
	Dtemp
	Dflags  
	BL2
	CH2
	CL2
	
	VAC_H	;Volt alimentation,Calibr (temprature critique) en u de 4.89mV, stocke en EEPROM0 et 1
	VAC_L
	VSC_H	;idem, pour la sonde (thermistance dans la culasse), stocke en EEP  2 et 3
	VSC_L
	
	VAI_H	;V alim instantane
	VAI_L
	VSI_H	;Vsonde instantane
	VSI_L
	
	V_L		;rempli par la SUB LECVT, V_L ici et V_H dans w
	
	FAL	;Flag alarme
	FBZOFF	;Flag arret du buzzer si BP pouss, mais la lampe reste allume	

	TMP	;temporaire 
	CS	;temporaire
	endc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
START   ORG     0               
 		clrf	INTCON   
  	   	 goto    Main	   	 
Main                                                                                                                                                                        	
         	 call		INIT
 						;la temprature est donne par la pente VSonde/VAlim. A chaud, Rsonde donc VSonde est faible
rep						; Il y a alarme si VSI/VAI <= VSC/VAC, cad VAC*VSI <= VSC*VAI
	movfw	VAC_H		;VAlim calib ds acc A
	movwf	AH
	movfw	VAC_L
	movwf	AL	
	
	call	LECT_VS			;Vsonde instantane dans accu B
	movwf	BH
	movfw	V_L
	movwf	BL	
				; le produit sur 32 bits est dans BC. Comme on X deux nombres de 10 bits, soit 20bits, forcemment BH=0	
	call	D_mpy	;	VAC*VSI =A*B ds B (hi16), C (low16) A et B 10 bits soit 20b total ,donc BH=0
	movfw	BL
	movwf	BL2	;sauver le produit VAC*VSI
	movfw	CH
	movwf	CH2
	movfw	CL
	movwf	CL2
	
	movfw	VSC_H		;VSondeAlim calib ds accA
	movwf	AH
	movfw	VSC_L
	movwf	AL	
	
	call	LECT_VALIM			;Valim instantane dans accu B
	movwf	BH
	movfw	V_L
	movwf	BL	
	
	call	D_mpy	;	A*B ds B (hi), C (low) A et B 10 bits soit 20b total ,BH=0
					;le produitt VAI*VSC est dans BL,CH,CL car BH=0	
	
	call	COMP	;comparer les eux produits et set FALarme si necessaire
	
	btfss	FAL,0
	goto alloff		;pas d'alarme
	bsf	LAMPE		;alarme, LED obligatoire,qq soit FBZOFF
	btfsc	FBZOFF,0	;couper le buzzer si demand par BP
	goto	buzoff	;Flag on donc arret du buzzer
	bsf	BUZ	;pas demand, donc buzzer ON
vbp
	btfsc	BP		;1 si BP appuy
	bsf	FBZOFF,0		;BP on, arreter buzzer
	btfss	CLI			;Clignote?
	goto	rep			;non, retour
	bsf	BUZ		;BuZ on pour 1s 
	movlw	4		;attendre 1s
	call	WAIT_ns
	bcf	BUZ
	goto	rep
alloff
	bcf	LAMPE	;pas d'alarme, ni lampe ni buzzer
buzoff
	bcf	BUZ
	goto	vbp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BUZ_ON			;SUB
	bsf	BUZ
	return
	bcf	BUZ
	call	Wait_1ms
	call	Wait_1ms
	bsf	BUZ
	call	WAIT_1ms
	call	Wait_1ms
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHCK_CAL				;SUB voit si calibration necessaire, si oui on y reste pour toujours

	btfss	BP		;1 si BP appuy
	return		;BP off, pas de calibration
	
ca2
	call		LECT_VALIM	
	movwf	VAC_H		;lire VAlim cal
	movfw	V_L
	movwf	VAC_L
	
	call		LECT_VS	;VSonde cal
	movwf	VSC_H
	movfw	V_L
	movwf	VSC_L
	
	btfss	BP		;1 si BP appuy
	goto	ca1		;BP off, ecrire EEP
	
	call		LECT_VALIM	;BPon	
	movwf	VAI_H		;lire VAlim cal
	movfw	V_L
	movwf	VAI_L
	
	call		LECT_VS	;VSonde cal
	movwf	VSI_H
	movfw	V_L
	movwf	VSI_L

	btfsc	BP		;1 si BP appuy
	goto	ca2		;BP on, continuer  lire VA et VS
	
	movfw	VAC_H	;BP off, on stock VAlim et VSonde calibr
	call	WR_w_EEP	;on prend la paire VA,VSsuivant le dernier BPon
	movfw	VAC_L
	call	WR_w_EEP
	
	movfw	VSC_H	;
	call	WR_w_EEP
	movfw	VSC_L
	call	WR_w_EEP
ca3
	goto	$
ca1					;on prend la paire VA,VSsuivant le dernier BPon
	movfw	VAI_H	;BP off, on stock VAlim et VSonde calibr
	call	WR_w_EEP
	movfw	VAI_L
	call	WR_w_EEP
	
	movfw	VSI_H	;
	call	WR_w_EEP
	movfw	VSI_L
	call	WR_w_EEP
	goto	ca3	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
COMP				;SUB compare les deux produits
	clrf	FAL		;clear Flag Alarme
	movfw	BL2	;BL2,CH2,CL2 contiennent VAC*VSI
	subwf	BL,w;BL,CH,CL	 contiennent VAI*VSC
	btfss	STATUS,Z
	goto	cp1		;pas egaux
	
	movfw	CH2	;egaux
	subwf	CH,w
	btfss	STATUS,Z
	goto	cp2	;pas egaux
	
	movfw	CL2	;egaux
	subwf	CL,w
	btfss	STATUS,Z
	goto	cp3		;pas egaux	
	goto	csf		;gaux, set flag alarme
cp1
	movfw	BL
	subwf	BL2,w
	btfsc	STATUS,C
cret
	return	;BL2>BL
csf
	bsf	FAL,0	; BL2<B set alarme
	goto	cret
cp2
	movfw	CH
	subwf	CH2,w
	btfsc	STATUS,C
	goto	cret	;CH2>CH
	goto	csf	;CH2<CH
cp3
	movfw	CL
	subwf	CL2,w
	btfsc	STATUS,C	
	goto	cret	;CL2>CL
	goto	csf	;CL2<CL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
INIT						;SUB initialisation I/O

	clrf	PORTB				;precaution avant affectation 1/0
	clrf	PORTA
	bcf		status,irp			;accs indirect aux pages 0 et 1 pour FSR

 		
	banksel	TRISA			;bk1
	movlw	h'60'
	movwf	OSCCON		;pour 4MHz oscillateur  interne, OK aussi avec quartz

	movlw	b'00001100'		; A2,3 en entr analogique,A0,A1  en sortie numrique, buzzer et led
	movwf	TRISA			;	Voir les #DEFINE au dbut 						;
	movlw	b'00010001'		;B0 pin6  entre numerique du BPet B4 pin 10 du clignotant. Buz,Lumire : OUT
	movwf	TRISB			;						
;;;;;;;;;;;;;;;;;;;registre  ANSEL;;;;;;;;;;;;;;;;;;;;;
	clrf	ANSEL			;Toutes entres en numrique car FF au demarrage!!
						;Dclare en entre analogique  A2,3,(pattes 1,2,)
	bsf		ANSEL,2
	bsf		ANSEL,3			;idem                   
;;;;;;;;;;;;ADCON1;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	bsf		ADCON1,ADFM		;result right justified, 6msb ds ADRESH = 0 en bk 0
	bcf		ADCON1,ADCS2	;normal conversion clock(not/2)
	bcf		ADCON1,VCFG1	;Votage ref + 5V 
	bcf		ADCON1,VCFG0
;;;;;;;;;;;;;ADCON0;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	banksel	ADCON0			;bk 0

	clrf		ADCON0
	bsf		ADCON0,ADCS0	;conversion clock	Fosc/8 OK car <5MHz	
	bsf		ADCON0,ADON		;Alimenter A/D converter	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	bcf	LAMPE
	bcf	BUZ
	clrf	FAL
	clrf	FBZOFF
	
	banksel	EEADR		;pas de calibration, mode normal, lire l'EEP
	clrf		EEADR				;pointer en EEP zero	
	banksel 0
	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	
	call	CHCK_CAL		;voir si calibration demande, si oui  pas de retour
			
	call	RD_w_EEP	;initialiser les deux tensions critiques
	movwf	VAC_H	;en 0
	call RD_w_EEP
	movwf	VAC_L	;en 1
	
	call	RD_w_EEP	;initialiser les deux tensions critiques
	movwf	VSC_H	; en 2
	call RD_w_EEP
	movwf	VSC_L	;en 3	
	return	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LECT_V					;SUB lit le DAC ds V_L et w=V_H
	call		SetupDelay
	bsf		ADCON0,GO		;dmarrer conversion
	nop
	btfsc	ADCON0,GO		;1 tant que en cours
	goto	$-1

	banksel	ADRESL			;bk1
	movfw	ADRESL
	banksel	ADRESH			;bk0
	movwf	V_L
	movfw	ADRESH
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LECT_VALIM
	bcf		ADCON0,CHS2		;CAD sur patte 1,RA2,lire Valim
	bsf		ADCON0,CHS1		;
	bcf		ADCON0,CHS0	
	call		LECT_V			;H ds w, L ds V_L
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LECT_VS					;SUB lecture de VSonde
	bcf		ADCON0,CHS2		;CAD sur patte 2, RA3 011, lire Vsi
	bsf		ADCON0,CHS1		;ds accu B
	bsf		ADCON0,CHS0	
	call		LECT_V			;H ds w, L ds V_L
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RD_w_EEP				;SUB lit ds w l'EEP pointe par EEADR, puis on fait EEADR++
	banksel	EECON1		;Bank 3
	bcf		EECON1,EEPGD;b7=0 pointe vers EEP
	bsf		EECON1,RD	;b0 =1 pour ReaD

	banksel	EEDATA		;bk2
	movfw	EEDATA		;charger car
	incf	EEADR,f		;EEADR++
	banksel	PIR1		;bk0
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
SETUPDELAY					;Attente pour la conversion A to D
	movlw	3
	movwf	TMP
	decfsz	TMP,f
	goto	$-1
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_1ms					;SUB d'attente 1 ms
	movlw	d'250'			;attendre 1ms = 250X4mus
sd	addlw	-1		;                                                  1mus
	btfss	STATUS,Z	;                                                  1
	goto	sd		;                                                  2
	return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_50ms
	movlw	d'207'		;soit 50 ms.BP apput 8s augmente Taff de 50pnts environ
	movwf	DTEMP
	call	WAIT_1ms
	incfsz	DTEMP,f
	goto	$-2
	return	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_wms					;SUB attente w ms 
	movwf	cs
	call	wait_1ms
	decfsz	cs,f
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_ns						;SUB d'attente de n/4 s
	movwf	TMP
	movlw	d'100'
	call	WAIT_wms
	decfsz	TMP,f
	goto	$-2
	return
;;;;;;;;;;;;;

WR_w_EEP				;SUB ecrit w en EEP, l ou pointe EEADR. w detruit, puis on faitEEADR++
							;si EEADR repasse  0, on s'arrte en faisant battre l'aiguille du cadran
	movwf	TMP			;sauve w
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	movfw	TMP
	banksel	EECON1		;bk3
	btfsc	EECON1,WR	;encore occupe  ecrire?
	goto	$-1			;oui, ne pas toucher  EEADR!!!

	banksel	EEDATA		;bk2
	movwf	EEDATA		;met car ds EEDATA
	
	banksel	EECON1		;bk3
	bcf		EECON1,EEPGD;OK,b7=0 pointe vers EEP
	bsf		EECON1,WREN	;enable Write

	movlw	h'55'		;magic sequence
	movwf	EECON2		;registre virtuel
	movlw	h'AA'
	movwf	EECON2
	bsf		EECON1,WR	;set bit Write
	bcf		EECON1,WREN	;disable Write

						;pour simulateur!!!!!!!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	

	banksel	EEADR
	incf		EEADR,f		;EEADR++, sets Z=1 si EEADR=0
	banksel	0
	return		;pas 0, tout va bien
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
       #include <D_arith.inc>	;Package pour arith 16 bits
       ; b+a ds b;;;;;;;b  _ a  ds b;;;;;a*b  ds bHigh  cLow;;;;;;  b/a  res ds b, reste ds c
	end
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
